local L = AceLibrary("AceLocale-2.2"):new("Automaton_LootBOP")
Automaton_LootBOP = Automaton:NewModule("LootBOP", "AceEvent-2.0", "AceDebug-2.0")

L:RegisterTranslations("enUS", function() return {
    ["LootBOP"] = true,
	["Ignore BOP confirm message when not in a party or raid"] = true,
} end)

L:RegisterTranslations("koKR", function() return {
    ["LootBOP"] = "획득 메시지 무시",
	["Ignore BOP confirm message when not in a party or raid"] = "파티 또는 공격대시 아이템 획득 확인 메시지를 무시합니다.",
} end)

Automaton.options.args.lootbop = {
	type = 'toggle',
	name = L["LootBOP"],
	desc = L["Ignore BOP confirm message when not in a party or raid"],
	get = function() return Automaton:IsModuleActive("LootBOP") end,
	set = function(v) Automaton:ToggleModuleActive("LootBOP", v) end,
}

function Automaton_LootBOP:OnEnable()
	self:RegisterEvent("LOOT_BIND_CONFIRM")
end

function Automaton_LootBOP:LOOT_BIND_CONFIRM(slot)
	if GetNumPartyMembers() == 0 then
		self:Debug("AutoLooting...")
		ConfirmLootSlot(slot)
		StaticPopup_Hide("LOOT_BIND")
	end
end
