local L = AceLibrary("AceLocale-2.2"):new("Automaton_Summon")
Automaton_Summon = Automaton:NewModule("Summon", "AceEvent-2.0", "AceConsole-2.0", "AceDebug-2.0")

L:RegisterTranslations("enUS", function() return {
	["Summon"] = true,
	["Options for accepting summons."] = true,
	["Enabled"] = true,
	["Accept warlock or meeting stone summons automatically."] = true,
	["Delay"] = true,
	["With this option enabled, automatic summons are delayed for 100 seconds."] = true,
	["Accepting summon in 1:40..."] = true,
	["Accepting summon..."] = true,
} end)

L:RegisterTranslations("koKR", function() return {
	["Summon"] = "자동 소환",
	["Options for accepting summons."] = "소환에 관한 옵션을 설정합니다",
	["Enabled"] = "활성화",
	["Accept warlock or meeting stone summons automatically."] = "자동으로 흑마법사 또는 만남의 돌의 소환을 수락합니다.",
	["Delay"] = "지연",
	["With this option enabled, automatic summons are delayed for 100 seconds."] = "이 옵션이 활성화시, 자동 소환을 100초 동안 지연시킵니다.",
	["Accepting summon in 1:40..."] = "소환 수락 1:40...",
	["Accepting summon..."] = "소환 수락...",
} end)

Automaton.options.args.summon = {
	type = 'group',
	name = L["Summon"],
	desc = L["Options for accepting summons."],
	args = {
		toggle = {
			type = 'toggle',
			name = L["Enabled"],
			desc = L["Accept warlock or meeting stone summons automatically."],
			get = function() return Automaton:IsModuleActive("Summon") end,
			set = function(v) Automaton:ToggleModuleActive("Summon", v) end,
		},
		delay = {
			type = 'toggle',
			name = L["Delay"],
			desc = L["With this option enabled, automatic summons are delayed for 100 seconds."],
			get = function() return Automaton.db.profile.autoSummonDelay end,
			set = function(v) Automaton.db.profile.autoSummonDelay = v end,
		}
	}
}

function Automaton_Summon:OnEnable()
	self:RegisterEvent("CONFIRM_SUMMON")
end

function Automaton_Summon:Confirm()
	ConfirmSummon()
	StaticPopup_Hide("CONFIRM_SUMMON")
end

function Automaton_Summon:CONFIRM_SUMMON()
	if Automaton.db.profile.autoSummonDelay and not self:IsEventScheduled("Automaton_autoSummon") then
		self:Print(L["Accepting summon in 1:40..."])
		self:ScheduleEvent("Automaton_autoSummon", self.Confirm, 100, self)
	elseif not self:IsEventScheduled("Automaton_autoSummon") then
		self:Print(L["Accepting summon..."])
		self:Confirm()
	end
end