local core = Automaton
local module = core:NewModule("Unshapeshift", "AceEvent-2.0", "AceDebug-2.0")
Automaton_Unshapeshift = module

local L = AceLibrary("AceLocale-2.2"):new("Automaton_Unshapeshift")

L:RegisterTranslations("enUS", function() return {
    ["Unshapeshift"] = true,
	["Automatically unshapeshift when you receieve ui errors about being shapeshifted"] = true,
	["Shaman"] = true,
	["Ghost Wolf"] = true,
} end)

L:RegisterTranslations("koKR", function() return {
    ["Unshapeshift"] = "변신",
	["Automatically unshapeshift when you receieve ui errors about being shapeshifted"] = "변신 상태의 행동 불능 오류시 변신 상태를 해제합니다.",
	["Shaman"] = "주술사",
	["Ghost Wolf"] = "늑대 정령",
} end)


core.options.args.unshapeshift = {
	type = 'toggle',
	name = L['Unshapeshift'],
	desc = L['Automatically unshapeshift when you receieve ui errors about being shapeshifted'],
	get = function() return core:IsModuleActive("Unshapeshift") end,
	set = function(v) core:ToggleModuleActive("Unshapeshift", v) end,
}

function module:OnEnable()
	self:RegisterEvent("UI_ERROR_MESSAGE")
	self:RegisterEvent("TAXIMAP_OPENED")
end

local messages = {
	[ERR_CANT_INTERACT_SHAPESHIFTED] = true,
	[ERR_NOT_WHILE_SHAPESHIFTED] = true,
	[SPELL_FAILED_NOT_SHAPESHIFT] = true,
	[SPELL_FAILED_ONLY_UNDERWATER] = true,
	[ERR_NO_ITEMS_WHILE_SHAPESHIFTED] = true,
	[SPELL_FAILED_NO_ITEMS_WHILE_SHAPESHIFTED] = true,
}

function module:UI_ERROR_MESSAGE(msg)
	if messages[msg] then
		self:Unshapeshift()
	end
end

function module:TAXIMAP_OPENED()
	self:Unshapeshift(true)
end

function module:Unshapeshift(really)
	for i=1,GetNumShapeshiftForms() do
		local _,name, active = GetShapeshiftFormInfo(i)
		if active and (really or not (name == "Flight Form")) then
			CastShapeshiftForm(i)
			return true
		end
	end
	if UnitClass("player") == L["Shaman"] then
		CancelPlayerBuff(L["Ghost Wolf"])
	end
end
